{
  inputs = {
    nixpkgs.url = "github:nixos/nixpkgs/nixpkgs-unstable";
  };

  outputs = inputs@{ nixpkgs, ... }: let
    systems = [ "aarch64-linux" "x86_64-linux" ];
    forAllSystems = nixpkgs.lib.genAttrs systems;
  in {
    nixosModules = {
      akkoma = import ./akkoma.nix;
    };

    packages = forAllSystems (system: let 
      pkgs = nixpkgs.legacyPackages.${system}; 
    in {
      mkEmotePack = { 
        src, 
        name, 
        version ? "v0.0.1", 
        convertSVGs ? false 
      }: pkgs.stdenvNoCC.mkDerivation {
        inherit src name version;

        buildPhase = ''
          cp -r $src/ $out/
        '';
      };
    });
  };
}